/*
 * Copyright (C) 2005 Stan Chesnutt.  All rights reserved.  You are welcome
 * to reuse this code in any project, commercial or otherwise, as long as
 * you mention my name in the documentation for the program (perhaps in
 * an "about" box, or a credit page, etc).
 *
 * comments/questions to chesnutt at gmail dot com
 *
 * $Header: /home/cvs//dancinglinks/Node.java,v 1.2 2006/01/03 23:29:45 chesnutt Exp $
 */

/*
 * Implement the node object which populates the sparse matrix
 */
class Node {
    Node left;
    Node right;
    Node up;
    Node down;
    ColumnNode column;
    int rowNumber;
    int label;

    /*
     * Create a self-referential node
     */
    Node(int rowNumber, int label) {
        this.left = this;
        this.right = this;
        this.up = this;
        this.down = this;
        this.rowNumber = rowNumber;
        this.label = label;
    }

	void setLeft(Node left) { this.left = left; }
    void setRight(Node right) { this.right = right; }
    void setUp(Node up) { this.up = up; }
	void setDown(Node down) { this.down = down; }
	void setColumn(ColumnNode column) { this.column = column; }
	/*
	 *  XXX: Changing the following seven lines to protected
	 *  increases execution speed by over 300%
	 */ 
	Node getLeft() { return left; }
	Node getRight() { return right; }
	Node getUp() { return up; }
	Node getDown() { return down; }
	ColumnNode getColumn() { return column; }
	int getLabel() { return(label); }
	int getRowNumber() { return(rowNumber); }
}
