
/*
 * Copyright (C) 2005 Stan Chesnutt.  All rights reserved.  You are welcome
 * to reuse this code in any project, commercial or otherwise, as long as
 * you mention my name in the documentation for the program (perhaps in
 * an "about" box, or a credit page, etc).
 *
 * comments/questions to chesnutt at gmail dot com
 *
 * $Header: /home/cvs//dancinglinks/Sudoku.java,v 1.3 2006/01/03 23:29:45 chesnutt Exp $
 */
public class Sudoku
{
	long solutions;
	long lastSolutionReport;
	long lastSolutionReportTime;
    private class SudokuSolution implements SudokuSolutionHandler {
        public void handleSolution(int solution[][]) {
//            for (int row = 0; row < 9; row++) {
//                for (int column = 0; column < 9; column++)
//                    System.out.print((solution[row][column]) + " ");
//
//                System.out.println();
//            }
//
//            System.out.println("-----------------");
        	solutions++;
        	if ((solutions%1000)==0) {
	        	long thisSolutionTime = System.currentTimeMillis();
	        	if ((thisSolutionTime - lastSolutionReportTime)>1000L) {
	        		System.out.println("Solutions: " + solutions + " (" + ((1000*(solutions - lastSolutionReport))/(thisSolutionTime - lastSolutionReportTime)) + "/s)");
	                lastSolutionReport=solutions;
	        		lastSolutionReportTime = thisSolutionTime;
	        	}
        	}
        }
    }

    public void solvePuzzle(int puzzle[][]) {
        DancingLinksSudoku s = new DancingLinksSudoku(puzzle,
                                                      new SudokuSolution());
        solutions=0;
    	long start = System.currentTimeMillis();
        lastSolutionReport=solutions;
    	lastSolutionReportTime = start;
        s.solveit();
        System.out.println((System.currentTimeMillis()-start) + " ms " + solutions + " solutions");
    }

    public static void main(String args[]) {
		Sudoku sudoku = new Sudoku();
		int puzzle_blank[][] = {
			{0, 0, 0,  0, 0, 0,  0, 0, 0},
			{0, 0, 0,  0, 0, 0,  0, 0, 0},
			{0, 0, 0,  0, 0, 0,  0, 0, 0},
			
			{0, 0, 0,  0, 0, 0,  0, 0, 0},
			{0, 0, 0,  0, 0, 0,  0, 0, 0},
			{0, 0, 0,  0, 0, 0,  0, 0, 0},
			
			{0, 0, 0,  0, 0, 0,  0, 0, 0},
			{0, 0, 0,  0, 0, 0,  0, 0, 0},
			{0, 0, 0,  0, 0, 0,  0, 0, 0}
		};
		
		sudoku.solvePuzzle(puzzle_blank);
    }
}
